
#ifndef WEBSERVER_H
#define WEBSERVER_H

#include <QObject>
#include <QHostAddress>
#include <QString>
#include <QByteArray>

class QTcpServer;
class QTcpSocket;
class QEvent;

class WebServer : public QObject
{
	Q_OBJECT

public:
    WebServer(const QHostAddress &host , quint16 port);
    virtual ~WebServer();

	void start();

private slots:
	void acceptConnection();
    void incomingData();
	void disconnected();
	void destroyed();

protected:
/*
    void incomingRequest(quint32 requestID,
                         const QHttpRequestHeader & header,
                         QxtWebContent *deviceContent);
*/

	bool eventFilter(QObject *obj, QEvent *event);

private:
	QTcpServer* m_pServer;

	QHostAddress m_host;
	quint16 m_port;

	
	quint32 m_count;
};

#endif // WEBSERVER_H
