#include <unistd.h>

#define MODE_C
//#define MODE_CPP
//#define MODE_QT

#ifdef MODE_C
#include <stdio.h>
#endif

#ifdef MODE_CPP
#include <fstream>
using namespace std;
#endif

#ifdef MODE_QT
#include <QFile>
#endif

#include "WorkerThread.h"

WorkerThread::WorkerThread(QObject* parent)
	: QThread(parent)
{
	m_bStop = false;
}

WorkerThread::~WorkerThread()
{
	
}

void WorkerThread::abort()
{
	m_bStop = true;
}

void WorkerThread::run()
{
	qDebug("[WorkerThread] Start worker thread");

	char* pBuffer;
	int sizeBuf;

	sizeBuf = 1000000;

	int iCount=4000;

#ifdef MODE_C
	qDebug("[WorkerThread] Mode C");
	FILE * pFile;
	pFile = fopen ("fileout.dat" , "wb");
	if(pFile){
		while(iCount>0 && !m_bStop){
			//qDebug("[WorkerThread] Remaining: %d", iCount);

			pBuffer = (char*)malloc(sizeBuf * sizeof(char));

			fwrite (pBuffer, 1, sizeBuf, pFile);
			fflush (pFile);

			free(pBuffer);
			pBuffer = NULL;

			iCount--;

			//usleep(100);
		}
	}
	qDebug("[WorkerThread] Closing the file");
	fclose (pFile);
#endif

#ifdef MODE_CPP
	qDebug("[WorkerThread] Mode CPP");
	ofstream outfile ("fileout.dat", ofstream::binary);
	while(iCount>0 && !m_bStop){
		pBuffer = (char*)malloc(sizeBuf * sizeof(char));

		outfile.write (pBuffer, sizeBuf);
		iCount--;

		free(pBuffer);
		pBuffer = NULL;
	}

	qDebug("[WorkerThread] Closing the file");
	outfile.close();
#endif

#ifdef MODE_QT
	qDebug("[WorkerThread] Mode QT");
	QFile outfile("fileout.dat");
	if(outfile.open(QIODevice::WriteOnly)){
		while(iCount>0 && !m_bStop){
			pBuffer = (char*)malloc(sizeBuf * sizeof(char));

			outfile.write (pBuffer, sizeBuf);
			iCount--;

			free(pBuffer);
			pBuffer = NULL;
		}
	}

	qDebug("[WorkerThread] Closing the file");
	outfile.close();
#endif

	qDebug("[WorkerThread] End worker thread");
}
